zoukankan      html  css  js  c++  java
  • leetcode assign-cookies

    455. Assign Cookies
    Easy

    Assume you are an awesome parent and want to give your children some cookies. But, you should give each child at most one cookie. Each child i has a greed factor gi, which is the minimum size of a cookie that the child will be content with; and each cookie j has a size sj. If sj>= gi, we can assign the cookie j to the child i, and the child i will be content. Your goal is to maximize the number of your content children and output the maximum number.

    Note:
    You may assume the greed factor is always positive. 
    You cannot assign more than one cookie to one child.

    Example 1:

    Input: [1,2,3], [1,1]
    
    Output: 1
    
    Explanation: You have 3 children and 2 cookies. The greed factors of 3 children are 1, 2, 3. 
    And even though you have 2 cookies, since their size is both 1, you could only make the child whose greed factor is 1 content.
    You need to output 1.
    

    Example 2:

    Input: [1,2], [1,2,3]
    
    Output: 2
    
    Explanation: You have 2 children and 3 cookies. The greed factors of 2 children are 1, 2. 
    You have 3 cookies and their sizes are big enough to gratify all of the children, 
    You need to output 2.
    题意:
      给了孩子的贪婪参数,饼干的大小,求可以满足最多多少孩子。
    思路:
      最节约的分给孩子饼干就可以得到最后最多。贪心。
    代码:
    class Solution {
    public:
        int findContentChildren(vector<int>& g, vector<int>& s) {
            int ans = 0;
            sort(g.begin(),g.end());
            sort(s.begin(),s.end());//排好序
            for(int i = 0;i < g.size();i++){//遍历孩子,找到最低能满足要求的饼干给他,并标记饼干已经分出,分给后找下一个孩子
                for(int j = 0;j < s.size();j++){
                    if(g[i] <= s[j]){
                        s[j] = 0;
                        ans++;
                        break;
                    }
                }
            }
            return ans;
        }
    };

     改进:

    每次找到合适的饼干后,之后的孩子只能得到尺寸不小于当前的饼干,所以,j=0放前面就好。

    class Solution {
    public:
        int findContentChildren(vector<int>& g, vector<int>& s) {
            int ans = 0;
            sort(g.begin(),g.end());
            sort(s.begin(),s.end());
            int j = 0;
            for(int i = 0;i < g.size();i++){
                for(;j < s.size();j++){
                    if(g[i] <= s[j]){
                        s[j] = 0;
                        ans++;
                        break;
                    }
                }
            }
            return ans;
        }
    };
  • 相关阅读:
    C#设计模式(2)——简单工厂模式
    C#设计模式(1)——单例模式
    静态变量与静态方法
    在服务器操作系统上使用TeamViewer
    51 nod 1439 互质对(Moblus容斥)
    51 nod 1495 中国好区间
    51nod 1103 N的倍数(抽屉原理)
    51 nod 1427 文明 (并查集 + 树的直径)
    51nod 1486 大大走格子(容斥原理)
    hihocoder 1388 fft循环矩阵
  • 原文地址:https://www.cnblogs.com/gudygudy/p/10366249.html
Copyright © 2011-2022 走看看